summaryrefslogtreecommitdiff
path: root/tests/misc/date-sec
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2004-03-15 09:11:20 +0000
committerJim Meyering <jim@meyering.net>2004-03-15 09:11:20 +0000
commit4b7f7127023ecffe8b3e562530ff5805c6d82673 (patch)
treee2f9a1a84a7a497ad185d196fc6d10baea3fa577 /tests/misc/date-sec
parentec55878bfe6040b987744ac009f0f160df76a235 (diff)
downloadcoreutils-4b7f7127023ecffe8b3e562530ff5805c6d82673.tar.xz
New file, to test for just-fixed bug in date.
See today's change in lib/getdate.y.
Diffstat (limited to 'tests/misc/date-sec')
-rwxr-xr-xtests/misc/date-sec45
1 files changed, 45 insertions, 0 deletions
diff --git a/tests/misc/date-sec b/tests/misc/date-sec
new file mode 100755
index 000000000..117c95b50
--- /dev/null
+++ b/tests/misc/date-sec
@@ -0,0 +1,45 @@
+#!/bin/sh
+# Ensure that a command like
+# `date --date="21:04 +0100" +%S' always prints `00'.
+# Before coreutils-5.2.1, it would print the seconds from the current time.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ date --version
+fi
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+n=0
+# Ensure that the current number of seconds is not just before `00'.
+s=`date +%S`
+case "$s" in
+ 58) n=3;;
+ 59) n=2;;
+ 00) n=1;;
+esac
+
+# If necessary, wait for the system clock to pass the minute mark.
+test $n = 0 || { echo sleeping for $n seconds...; sleep $n; }
+
+s=`date --date="21:04 +0100" +%S`
+case "$s" in
+ 00) ;;
+ *) fail=1;;
+esac
+
+(exit $fail); exit $fail